import networkx as nx
from networkx.algorithms import isomorphism


# We declare the board states where FP must play differently from her
# usual strategy in order to check this via nx.is_isomorphic while the algorithm runs.
stage_5_graph_1 = nx.Graph()
stage_5_graph_1.add_edges_from([(1,2),(1,3),(2,3),(2,4),(3,10)], colour= 'FP')
stage_5_graph_1.add_edges_from([(1,10),(2,10),(2,11),(3,4),(10,11)], colour= 'SP')
stage_5_graph_2 = nx.Graph()
stage_5_graph_2.add_edges_from([(1,2),(1,3),(2,3),(2,4),(3,10)], colour= 'FP')
stage_5_graph_2.add_edges_from([(1,10),(1,11),(2,10),(3,4),(2,11)], colour= 'SP')
stage_5_graph_3 = nx.Graph()
stage_5_graph_3.add_edges_from([(1,2),(1,3),(2,3),(2,4),(3,10)], colour= 'FP')
stage_5_graph_3.add_edges_from([(1,10),(2,10),(3,4),(2,11),(10,12)], colour= 'SP')
stage_5_graph_4 = nx.Graph()
stage_5_graph_4.add_edges_from([(1,2),(1,3),(2,3),(2,4),(3,10)], colour= 'FP')
stage_5_graph_4.add_edges_from([(1,10),(2,10),(3,4),(2,11),(11,12)], colour= 'SP')

stage_6_graph_1 = nx.Graph()
stage_6_graph_1.add_edges_from([(1,2),(1,3),(2,3),(1,10)], colour= 'FP')
stage_6_graph_1.add_edges_from([(1,11),(2,10),(3,10),(10,11)], colour= 'SP')
stage_6_graph_2 = nx.Graph()
stage_6_graph_2.add_edges_from([(1,2),(1,3),(2,3),(1,10)], colour= 'FP')
stage_6_graph_2.add_edges_from([(1,11),(2,10),(3,10),(10,12)], colour= 'SP')

stage_5_graphs = [stage_5_graph_1,stage_5_graph_2,stage_5_graph_3,stage_5_graph_4]
stage_6_graphs = [stage_6_graph_1,stage_6_graph_2]

# Declaring the function to check isomorphism w.r.t. edge colour.
em = isomorphism.categorical_edge_match('colour', None)

# To measure maximum number of rounds of the game, we introduce a variable.
maximum_game_length_number_of_moves = 0
maximum_game_length_board = nx.Graph()

# We introduce another variable to measure the maximum board size 
# that FP requires to execute her strategy.
number_of_required_vertices = 0


# We declare eight graphs that we will check for
# during the course of the game via nx.subgraph_is_isomorphic.
K_four_minus = nx.Graph()
K_four_minus.add_edges_from([(1,2,{'colour':'FP'}),(1,3,{'colour':'FP'}),(1,4,{'colour':'FP'}),(2,3,{'colour':'FP'}),(2,4,{'colour':'FP'}),(3,4,{'colour':'SP'})])

FP_win_graph = nx.Graph()
FP_win_graph.add_edges_from([(1,2),(1,3),(1,4),(2,3),(2,4),(3,4)],colour='FP')

SP_win_graph = nx.Graph()
SP_win_graph.add_edges_from([(1,2),(1,3),(1,4),(2,3),(2,4),(3,4)],colour='SP')

FP_threat_graph = nx.Graph()
FP_threat_graph.add_edges_from([(1,2),(1,3),(1,4),(2,3),(2,4)],colour='FP')

SP_threat_graph = nx.Graph()
SP_threat_graph.add_edges_from([(1,2),(1,3),(1,4),(2,3),(2,4)],colour='SP')

FP_triangle = nx.Graph()
FP_triangle.add_edges_from([(1,2),(2,3),(3,1)],colour='FP')

SP_triangle = nx.Graph()
SP_triangle.add_edges_from([(1,2),(2,3),(3,1)],colour='SP')

FP_path_length_2 = nx.Graph()
FP_path_length_2.add_edges_from([(1,2),(2,3)], colour='FP')




# Define promising graph type (1)
promising_graph_type_one = nx.Graph()
promising_graph_type_one.add_edges_from([(1,2,{'colour':'FP'}),
                                         (1,3,{'colour':'FP'}),
                                         (2,3,{'colour':'FP'}),
                                         (1,4,{'colour':'FP'}),
                                         (1,5,{'colour':'FP'}),
                                         (3,4,{'colour':'FP'}),
                                         (2,4,{'colour':'SP'})])

# Define promising graph type (2)
promising_graph_type_two = nx.Graph()
promising_graph_type_two.add_edges_from([(1,2,{'colour':'FP'}),
                                         (1,3,{'colour':'FP'}),
                                         (2,3,{'colour':'FP'}),
                                         (1,4,{'colour':'FP'}),
                                         (1,5,{'colour':'FP'})])

# Define promising graph type (3)
promising_graph_type_three = nx.Graph()
promising_graph_type_three.add_edges_from([(1,2,{'colour':'FP'}),
                                           (1,3,{'colour':'FP'}),
                                           (2,3,{'colour':'FP'}),
                                           (1,4,{'colour':'FP'}),
                                           (1,5,{'colour':'FP'}),
                                           (1,6,{'colour':'FP'}),
                                           (2,4,{'colour':'SP'}),
                                           (2,5,{'colour':'SP'})])

# Define promising graph type (4)
promising_graph_type_four = nx.Graph()
promising_graph_type_four.add_edges_from([(1,2,{'colour':'FP'}),
                                          (1,3,{'colour':'FP'}),
                                          (2,3,{'colour':'FP'}),
                                          (1,4,{'colour':'FP'}),
                                          (1,5,{'colour':'FP'}),
                                          (1,6,{'colour':'FP'}),
                                          (2,4,{'colour':'SP'}),
                                          (5,6,{'colour':'SP'})])

# Define promising graph type (5)
promising_graph_type_five = nx.Graph()
promising_graph_type_five.add_edges_from([(1,2,{'colour':'FP'}),
                                          (1,3,{'colour':'FP'}),
                                          (2,3,{'colour':'FP'}),
                                          (1,4,{'colour':'FP'}),
                                          (1,5,{'colour':'FP'}),
                                          (1,6,{'colour':'FP'}),
                                          (1,7,{'colour':'FP'}),
                                          (2,4,{'colour':'SP'}),
                                          (2,5,{'colour':'SP'}),
                                          (2,6,{'colour':'SP'}),
                                          (3,5,{'colour':'SP'}),
                                          (4,6,{'colour':'SP'})])

# Define promising graph type (6)
promising_graph_type_six = nx.Graph()
promising_graph_type_six.add_edges_from([(1,2,{'colour':'FP'}),
                                         (1,3,{'colour':'FP'}),
                                         (2,3,{'colour':'FP'}),
                                         (1,4,{'colour':'FP'}),
                                         (1,5,{'colour':'FP'}),
                                         (1,6,{'colour':'FP'}),
                                         (1,7,{'colour':'FP'}),
                                         (2,4,{'colour':'SP'}),
                                         (2,5,{'colour':'SP'}),
                                         (2,6,{'colour':'SP'}),
                                         (3,4,{'colour':'SP'}),
                                         (3,5,{'colour':'SP'})])

# Define a variation of promising graph type (6)
# This is a subgraph of the promising graph of type (6), 
# the SP edge (2,5) is deleted.
promising_graph_type_six_variation = nx.Graph()
promising_graph_type_six_variation.add_edges_from([(1,2,{'colour':'FP'}),
                                         (1,3,{'colour':'FP'}),
                                         (2,3,{'colour':'FP'}),
                                         (1,4,{'colour':'FP'}),
                                         (1,5,{'colour':'FP'}),
                                         (1,6,{'colour':'FP'}),
                                         (1,7,{'colour':'FP'}),
                                         (2,4,{'colour':'SP'}),
                                         (2,6,{'colour':'SP'}),
                                         (3,4,{'colour':'SP'}),
                                         (3,5,{'colour':'SP'})])

# Define a list containing all promising graphs
promising_graphs = [promising_graph_type_one,
                    promising_graph_type_two,
                    promising_graph_type_three,
                    promising_graph_type_four,
                    promising_graph_type_five,
                    promising_graph_type_six,
                    promising_graph_type_six_variation]

# Define a list that contains the vulnerable edges for each promising graph.
# That is the edgesets that must be added to check whether
# there is a realised promising graph on the board.
promising_graphs_edgesets_to_check = {promising_graph_type_one: [],
                                      promising_graph_type_two: [[(2,4,'SP')]],
                                      promising_graph_type_three: [[(2,6,'SP'),(3,5,'SP')]],
                                      promising_graph_type_four: [[(2,5,'SP'),(2,6,'SP')]],
                                      promising_graph_type_five: [[(2,7,'SP'),(3,4,'SP'),(3,6,'SP')]],
                                      promising_graph_type_six: [[(2,7,'SP'),(3,6,'SP'),(5,6,'SP')]],
                                      promising_graph_type_six_variation: [[(2,7,'SP'),(3,6,'SP'),(5,6,'SP')]]}


# The number of edges that will be added for each promising graph
# undtil FP finishes her K^4.
# This is only used to calculate the maximum game length.
promising_graphs_moves_until_FP_win = {promising_graph_type_one: 2,
                                      promising_graph_type_two: 4,
                                      promising_graph_type_three: 6,
                                      promising_graph_type_four: 6,
                                      promising_graph_type_five: 8,
                                      promising_graph_type_six: 8,
                                      promising_graph_type_six_variation: 8}


def SP_win_checker(board):
    # This function checks whether there is a monochromatic K^4 by SP on the board
    GM = isomorphism.GraphMatcher(board,SP_win_graph,edge_match=em)
    return GM.subgraph_is_isomorphic()

def check_whether_promising_graph_is_realised(board,promising_graph):
    # This function checks whether a promising graph is 
    # realised on the board.
    GM = isomorphism.GraphMatcher(board,promising_graph,edge_match=em)
    suitable = False
    if GM.subgraph_is_isomorphic():
        # we check every possible embedding of the promising graph
        # into the board.
        for inv_mapping in GM.subgraph_isomorphisms_iter():
            global maximum_game_length_board
            global maximum_game_length_number_of_moves
            if promising_graph == promising_graph_type_one:
                # For the type (1) promising graph we need not add edges.
                # Thus we also need not check for threats by SP or a monochromatic K^4 by SP
                # because then either FP has a forced move or FP already has lost respectively,
                # Thus we would not reach this point of the algorithm.
                suitable = True
                if board.number_of_edges() + 2 > maximum_game_length_number_of_moves:
                    maximum_game_length_board.add_edges_from(board.edges(data=True))
                    maximum_game_length_board.add_nodes_from(board.nodes(data=True))
                    maximum_game_length_number_of_moves = board.number_of_edges() + 2
            else:
                # If the promising graph is of a type other than (1),
                # we add the vulnerable edges to the board.
                # The position is given by the mapping.
                mapping = {value: key for key, value in inv_mapping.items()}
                for possible_edges in promising_graphs_edgesets_to_check[promising_graph]:
                    aux_board = nx.Graph()
                    aux_board.add_edges_from(board.edges(data=True))
                    for edge in possible_edges:
                        aux_board.add_edge(mapping[edge[0]], mapping[edge[1]], colour=edge[2])
                    if not threat_checker(aux_board,'SP') and not SP_win_checker(aux_board):
                        # If the promising graph is realised,
                        # we calculate the number of moves until FP wins.
                        suitable = True
                        moves_until_FP_win = promising_graphs_moves_until_FP_win[promising_graph]
                        if board.number_of_edges() + moves_until_FP_win > maximum_game_length_number_of_moves:
                            maximum_game_length_board.add_edges_from(board.edges(data=True))
                            maximum_game_length_board.add_nodes_from(board.nodes(data=True))
                            maximum_game_length_number_of_moves = board.number_of_edges() + moves_until_FP_win
                        break
                if suitable:
                    break
    return suitable


def FP_degree(vertex, board):
    # This function returns the FP degree of a vertex of the board.
    degree = 0
    for neighbour in nx.all_neighbors(board, vertex):
        if board[vertex][neighbour]['colour'] == 'FP':
            degree += 1
    return degree

  

def SP_degree(vertex, board):
    # This function returns the SP degree of a vertex of the board.
    degree = 0
    for neighbour in nx.all_neighbors(board, vertex):
        if board[vertex][neighbour]['colour'] == 'SP':
            degree += 1
    return degree




def win_checker(board):
    # This function checks whether there is a monochromatic K^4 on the board
    for K_4 in [FP_win_graph,SP_win_graph]:
        GM = isomorphism.GraphMatcher(board,K_4,edge_match=em)
        if GM.subgraph_is_isomorphic():
            return list(list(GM.subgraph_isomorphisms_iter())[0].keys())
    return []



    
def threat_checker(board, colour):
    # This function checks whether there is a monochromatic K^4_- in the colour
    # of the player that is given s.t. the last edge is unclaimed.
    # It returns a list of all such non-edges on the board.
    threats = []
    possible_graphs = {'FP': FP_threat_graph, 'SP': SP_threat_graph}
    graph_to_use = possible_graphs[colour]
    GM = isomorphism.GraphMatcher(board,graph_to_use,edge_match=em)
    if GM.subgraph_is_isomorphic():
        for mapping in GM.subgraph_isomorphisms_iter():
            subboard = board.subgraph(mapping.keys())
            threat_edge = tuple(*nx.non_edges(subboard))
            if threat_edge not in threats and (threat_edge[1],threat_edge[0]) not in threats:
                threats.append(threat_edge)
    return threats


def K_four_minus_checker(board):
    # This function checks whether there is a monochromatic K^4_- in FPs colour 
    # s.t. the last edge is claimed by SP
    # It either returns an empty list or a list of four vertices such that 
    # the subgraph of the board induced by these vertices is such a graph.
    # global K_four_minus
    GM = isomorphism.GraphMatcher(board,K_four_minus,edge_match=em)
    if GM.subgraph_is_isomorphic():
        return list(list(GM.subgraph_isomorphisms_iter())[0].keys())
    else:
        return []



def can_get_K_four_minus(board):
    # This function checks whether there is a set of four vertices s.t.
    # the induced subgraph on these vertices has precisely 5 claimed edges,
    # four in the colour of FP and one in the colour of SP
    K_four_minus_seed_1 = nx.Graph()
    K_four_minus_seed_1.add_edges_from([(1,2,{'colour':'FP'}),(1,3,{'colour':'FP'}),(2,3,{'colour':'FP'}),(1,4,{'colour':'FP'}),(3,4,{'colour':'SP'})])
    K_four_minus_seed_2 = nx.Graph()
    K_four_minus_seed_2.add_edges_from([(1,2,{'colour':'FP'}),(2,3,{'colour':'FP'}),(3,4,{'colour':'FP'}),(4,1,{'colour':'FP'}),(1,3,{'colour':'SP'})])
    K_four_minus_seed_3 = nx.Graph()
    K_four_minus_seed_3.add_edges_from([(1,2,{'colour':'FP'}),(1,3,{'colour':'FP'}),(2,3,{'colour':'FP'}),(1,4,{'colour':'FP'})])
    K_four_minus_seed_4 = nx.Graph()
    K_four_minus_seed_4.add_edges_from([(1,2,{'colour':'FP'}),(2,3,{'colour':'FP'}),(3,4,{'colour':'FP'}),(4,1,{'colour':'FP'})])
    K_four_minus_seeds = [K_four_minus_seed_1,K_four_minus_seed_2,K_four_minus_seed_3,K_four_minus_seed_4]
    for K_four_minus_seed in K_four_minus_seeds:
        GM = isomorphism.GraphMatcher(board,K_four_minus_seed,edge_match=em)
        if GM.subgraph_is_isomorphic():
            return list(list(GM.subgraph_isomorphisms_iter())[0].keys())
    # Otherwise FP cannot get a K^4_- and we return an empty list.
    return []


def flagged_vertex_present(board):
    # This function checks whether there is a vertex on the board that 
    # has any property assigned to it.
    for vertex in board.nodes(data=True):
        if vertex[1]:
            return True
    return False


def find_vertex_with_property(board, key, value):
    # This function finds a vertex on the board that 
    # has a specific property assigned to it (via a key, value pair).
    for vertex in board.nodes(data=True):
        if key in vertex[1]:
            if vertex[1][key] == value:
                return vertex[0]


def find_FP_triangle(board):
    # This function checks whether there is a monochromatic triangle in FPs colour on the board.
    # It either returns an empty list or a list of the first set of three nodes
    # whose induced subgraph is such a monochromatic triangle.
    GM = isomorphism.GraphMatcher(board,FP_triangle,edge_match=em)
    if GM.subgraph_is_isomorphic():
            return list(list(GM.subgraph_isomorphisms_iter())[0].keys())
    return []


def find_highest_SP_degree_in_substructure(board, vertexset):
    # This function returns the vertex with the highest SP-degree (in the board)
    # of a given set of vertices.
    highest_degree_vertex = vertexset[0]
    for vertex in vertexset[1:]:
        if SP_degree(vertex, board) > SP_degree(highest_degree_vertex, board):
            highest_degree_vertex = vertex
    return highest_degree_vertex


def define_FP_favourite_vertex(board, KfourVertexset):
    # This function returns the vertex of the K^4 that FP should use throughout stage 3.
    # (Which will be flagged as FP_main on the board later on)
    # It is one of the vertices that is not incident with SPs edge of the K^4_-.
    # This means that FP decides for one of two vertices, say a and b.
    # If there is a monochromatic triangle of SP that uses one of these two vertices, 
    # suppose a, then FP wants to use a.
    # Otherwise, she wants to use the vertex of {a,b} 
    # that is incident with more edges of SP.
    SP_triangles = []
    GM = isomorphism.GraphMatcher(board,SP_triangle,edge_match=em)
    if GM.subgraph_is_isomorphic():
        for mapping in GM.subgraph_isomorphisms_iter():
            triangle = set(mapping.keys())
            if triangle not in SP_triangles:
                SP_triangles.append(triangle)
    the_graph = board.subgraph(KfourVertexset)
    for edge in the_graph.edges():
        if board[edge[0]][edge[1]]['colour'] == 'SP':
            potential_vertices = list(KfourVertexset)
            potential_vertices.remove(edge[0])
            potential_vertices.remove(edge[1])
            break
    if SP_degree(potential_vertices[0],board) != SP_degree(potential_vertices[1], board) or not SP_triangles:
        return find_highest_SP_degree_in_substructure(board, potential_vertices)
    else:
        for triangle in SP_triangles:
            for vtx in potential_vertices:
                if vtx in triangle:
                    return vtx
        return find_highest_SP_degree_in_substructure(board, potential_vertices)


def define_SP_favourite_vertex(board, vertexsubset):
    # This function returns the vertex of the K^4 that FP wants SP to use throughout stage 3.
    # It is the unique vertex of FPs K^4_- that is neither incident with SPs edge in the K^4_-
    # nor the vertex that FP wants to use.
    subboard = board.subgraph(vertexsubset)
    for edge in subboard.edges():
        if board[edge[0]][edge[1]]['colour'] == 'SP':
            potential_vertices = list(vertexsubset)
            potential_vertices.remove(edge[0])
            potential_vertices.remove(edge[1])
            break
    potential_vertices.remove(define_FP_favourite_vertex(board, vertexsubset))
    return potential_vertices[0]


def FP_triangle_finish_checker(board):
    # This function returns a list of all non-edges of the board that if claimed by FP
    # would be part of a monochromatic triangle.
    threats = []
    GM = isomorphism.GraphMatcher(board,FP_path_length_2,edge_match=em)
    if GM.subgraph_is_isomorphic():
        for mapping in GM.subgraph_isomorphisms_iter():
            subboard = board.subgraph(mapping.keys())
            missing_edge = tuple(*nx.non_edges(subboard))
            if missing_edge not in threats and (missing_edge[1],missing_edge[0]) not in threats:
                threats.append(missing_edge)
    return threats

def triangle_builder(board, vertexset):
    # This function embodies the algorithm that FP uses 
    # at different situations of the game to build a monochromatic triangle.
    # More precisely, this is used in stages 1, 4, 5 and 6.
    # Since the vertexset on which FP wants to build the triangle is different 
    # at different stages of the game, this information is supplied.
    FP_edges_count = 0
    # We begin by checking how many edges FP has already claimed on the vertexset.
    subboard = board.subgraph(vertexset)
    for edge in subboard.edges():
        if subboard[edge[0]][edge[1]]['colour'] == 'FP':
            FP_edges_count += 1
    if FP_edges_count == 0:
        # If there are no FP edges, then FP claims the edge on 
        # the two vertices with the smallest SP degree of the vertexset.
        prio_vtcs = sorted(vertexset, key = lambda x : SP_degree(x, board))
        return (prio_vtcs[0],prio_vtcs[1])
    elif FP_edges_count == 1:
        # We check whether SP took an edge that is incident with
        # the previous one of FP.
        # If that is the case, FPs next edge should be using their mutual vertex
        # and a vertex of the vertexset with the smallest possible SP degree.
        SP_last_vtcs = sorted([(*foo, board.get_edge_data(*foo)) for foo in board.edges()], key = lambda x : x[2]['added_in_step'])[-1][:2]
        prio_FP_vtcs = sorted([vtx for vtx in vertexset if FP_degree(vtx, subboard) != 0], key = lambda x : SP_degree(x, board))
        prio_free_vtcs = sorted([vtx for vtx in vertexset if subboard.degree(vtx) == 0], key = lambda x : SP_degree(x, board))
        for vtx in prio_FP_vtcs:
            if vtx in SP_last_vtcs:
                return (vtx, prio_free_vtcs[0])
        # If SPs previous edge is disjoint from FPs but a subset of the vertexset,
        # then FP just claims an edge from one of the endvertives of her edge to 
        # the last remaining vertex of vertexset.
        if len(prio_free_vtcs) == 1:
            return (prio_FP_vtcs[0],prio_free_vtcs[0])
        # Otherwise SP did not claim an edge incident with 
        # FPs last edge and it also is not a subset of the vertexset.
        # We check whether all vertices of the vertexset other than
        # the ones incident with FPs edge have the same degree.
        same_degree = True
        the_degree = SP_degree(prio_free_vtcs[0],board)
        for vtx in prio_free_vtcs[1:]:
            if not the_degree == SP_degree(vtx, board):
                same_degree = False
                break
        # If same_degree is true we check whether at least one of the vertices
        # of the vertexset has edges that are also incident with
        # SP_left and SP_right. If that is the case, then FP plays to that vertex.
        if same_degree and the_degree >= 2:
            for vertex in prio_free_vtcs:
                if find_vertex_with_property(board, 'K_four_minus', 'SP_left') in board.neighbors(vertex) and find_vertex_with_property(board, 'K_four_minus', 'SP_right') in board.neighbors(vertex):
                    return (prio_FP_vtcs[0],vertex)
        # if same_degree is false, FP claims an edge from her previous edge
        # to the vertex of smallest possible SP degree but also making sure
        # that that vertex is not contained in SPs previous edge
        # (which is still possible if SPs previous edge was incident with exactly
        # one vertex of the vertexset that is not incident with FPs previous edge.)
        for vtx in prio_free_vtcs:
            if vtx in SP_last_vtcs:
                continue
            return (prio_FP_vtcs[0],vtx)
    else:
        # In this case there are at least 2 edges of FP on the vertexset.
        # First we check whether FP can just finish her triangle.
        finish_moves = FP_triangle_finish_checker(subboard)
        if finish_moves:
            return finish_moves[0]
        else:
            # Otherwise she should claim an edge s.t. the subgraph 
            # induced by her edges on the vertexset creates a star with three tips.
            # We first identify the centre vertex of the star.
            for vertex in vertexset:
                if FP_degree(vertex, subboard) >= 2:
                    centre_vertex = vertex
                    break
            FP_incident_vertices = [vtx for vtx in vertexset if FP_degree(vtx,subboard) != 0]
            potential_vertices = [vtx for vtx in vertexset if vtx not in FP_incident_vertices]
            # Only in stage 1, in case the first edge of SP was disjoint from 
            # the first edge of FP but SP prevents a FP triangle in the first 
            # three moves, FP's third edge should be incident with SP's first edge.
            aux_board = board.copy()
            for vertex in list(nx.isolates(aux_board)):
                aux_board.remove_node(vertex)
            special_triangle_situation = nx.Graph()
            special_triangle_situation.add_edges_from([(1,2),(1,3)],colour = 'FP')
            special_triangle_situation.add_edges_from([(2,3),(10,11)],colour = 'SP')
            if nx.is_isomorphic(aux_board, special_triangle_situation, edge_match=em):
                return (centre_vertex,sorted([vtx for vtx in board.nodes() if board.degree(vtx) == 1])[0])
            # FP wants to claim an edge incident with centre_vertex and 
            # another vertex x of the vertexset, s.t. for the two vertices u and w
            # of the vertexset that are incident with FP edges the edges 
            # (x,u) and (x,w) are unclaimed as well.
            for vertex in potential_vertices:
                suitable = True
                for incident_vtx in FP_incident_vertices[:3]:
                    if (incident_vtx,vertex) in subboard.edges():
                        suitable = False
                        break
                if suitable:
                    return (centre_vertex,vertex)


def promising_graph_present(board):
    # This function checks whether there is a promising graph on the board.
    for prom_graph in promising_graphs:
        if check_whether_promising_graph_is_realised(board,prom_graph):
            return True
    return False


def stage_five(board_edges, board_nodes = []):
    # This function executes the strategy for FP in stage 5
    rounds_played = len(board_edges)/2
    board = nx.Graph()
    board.add_edges_from(board_edges)
    board.add_nodes_from(board_nodes)
    # The smallest stage 5 graph has 10 edges, i.e. there were 5 rounds played.
    # In that case, we need to find out which vertex FPs next edges should be incident with ('FP_main')
    # and which vertices she wants SP to use ('SP_main', 'SP_right') 
    if rounds_played == 5:
        for vertex in board.nodes():
            if FP_degree(vertex, board) == 1:
                if SP_degree(vertex, board) == 1:
                    first_stage_5_vertex = vertex
            if FP_degree(vertex, board) == 2:
                SP_right_vertex = vertex
            if FP_degree(vertex, board) == 3:
                if SP_degree(vertex, board) == 2:
                    FP_main_vertex = vertex
                else:
                    SP_main_vertex = vertex
        return {'move': (FP_main_vertex,31), 'alg_stage': 5, 'special_case_position': {first_stage_5_vertex: 'p_0', 31: 'p_1', FP_main_vertex: 'FP_main', SP_main_vertex: 'SP_main', SP_right_vertex: 'SP_right'}, 'mapping': {first_stage_5_vertex:30}}
    elif rounds_played == 6:
        # FP checks how SP played
        if (find_vertex_with_property(board, 'special_case_position', 'SP_main'),find_vertex_with_property(board, 'special_case_position', 'p_1')) not in board.edges():
            # if SP did not claim one particular edge then FP can play as if she was in stage 3
            return {'move': (find_vertex_with_property(board, 'special_case_position', 'SP_main'),find_vertex_with_property(board, 'special_case_position', 'p_1')), 'alg_stage': 3,  'special_case_position': {find_vertex_with_property(board, 'special_case_position', 'p_1'): 'SP_left'}, 'mapping': {find_vertex_with_property(board, 'special_case_position', 'p_0'):20, find_vertex_with_property(board, 'special_case_position', 'p_1'):6}}
        else:
            # otherwise she can claim an edge incident with 'FP_main' and a fresh vertex
            return {'move': (find_vertex_with_property(board, 'special_case_position', 'FP_main'),32), 'alg_stage': 5, 'special_case_position': {32: 'p_2'}}
    elif rounds_played == 7:
        # FP checks how SP played.
        if (find_vertex_with_property(board, 'special_case_position', 'SP_main'),find_vertex_with_property(board, 'special_case_position', 'p_2')) not in board.edges() and (find_vertex_with_property(board, 'special_case_position', 'SP_right'),find_vertex_with_property(board, 'special_case_position', 'p_2')) not in board.edges() and (find_vertex_with_property(board, 'special_case_position', 'p_0'),find_vertex_with_property(board, 'special_case_position', 'p_1')) not in board.edges():
            # If he did not claim one of three particular edges,
            # then SP can switch to stage 3
            return {'move': (find_vertex_with_property(board, 'special_case_position', 'SP_main'),find_vertex_with_property(board, 'special_case_position', 'p_2')), 'alg_stage': 3,  'special_case_position': {find_vertex_with_property(board, 'special_case_position', 'p_2'): 'SP_left'}, 'mapping': {find_vertex_with_property(board, 'special_case_position', 'p_0'):20, find_vertex_with_property(board, 'special_case_position', 'p_1'):21, find_vertex_with_property(board, 'special_case_position', 'p_2'):6}}
        else:
            # otherwise she can claim an edge incident with 'FP_main' and a fresh vertex
            return {'move': (find_vertex_with_property(board, 'special_case_position', 'FP_main'),33), 'alg_stage': 6, 'special_case_position': {33: 'p_3'}}
    else:
        raise Exception('There should be no edges on this subboard or we should not end up here')


        
def stage_six(board_edges, board_nodes = []):
    # This function executes the strategy for FP in stage 6
    board = nx.Graph()
    board.add_edges_from(board_edges)
    board.add_nodes_from(board_nodes)
    # In turn 5 (i.e. 8 edges have already been claimed),
    # we want to register certain vertices of the board, which FP will need
    # later in the game.
    if len(board_edges) == 8:
        SP_vertices = []
        # We wants to flag the vertices of the monochromatic triangle of FP,
        # which we can simply identify by thei unique degrees in the baord
        # and the one additional vertex of FP-degree 1.
        for vertex in board.nodes():
            # The unique vertex of FP-degree 3 is the one that
            # FP wants to connect to fresh vertices in subsequent turns.
            if FP_degree(vertex, board) == 3:
                FP_main_vertex = vertex
            # The other two vertices of the monochromatic triangle are the ones
            # that FP desires SP to play to.
            elif FP_degree(vertex, board) == 2:
                SP_vertices.append(vertex)
            # The unique vertex of FP-degree 1 is sometimes
            # used later in the game by FP to build a triangle on.
            # We call it 'k'.
            elif FP_degree(vertex, board) == 1:
                p0 = vertex
        # The other two vertices of the monochromatic triangle will be called
        # FP_main and FP_right.
        # In this particular stage their roles are interchangeable,
        # the names are chosen to fit with the names used in stages 3 and 5.
        SP_left_vertex = SP_vertices[0]
        SP_right_vertex = SP_vertices[1]
        # After figuring out the roles of the vertices, FP wants to claim an edge
        # incident with FP_main and a fresh vertex.
        return {'move': (FP_main_vertex,30), 'special_case_position': {30: 'p_1', FP_main_vertex: 'FP_main', SP_left_vertex: 'SP_main', SP_right_vertex: 'SP_right', p0: 'p_0'}}
    else:
        # In a turn later than 5, we check whether there is a way for FP to win with threat moves.
        # If there is one from a previous turn, we just take the next planned move.
        # We begin by creating a list with all the p_i on the board
        list_of_p_i = []
        for vertex in board.nodes(data=True):
            if 'special_case_position' in vertex[1]:
                if vertex[1]['special_case_position'] in ['p_0','p_1','p_2','p_3','p_4']:
                    list_of_p_i.append(vertex[0])
        determined_moves = [x[0] for x in board.nodes.data('determined_finish') if x[1]]
        # We check whether FP already determined in a previous move how she can win.
        # This is either a list of edges where each edge claimed from the list 
        # (in the correct order) is a threat,
        # or it is a string with the information that FP should build a triangle
        # on the p_i.
        if determined_moves:
            return {'move': triangle_builder(board,list_of_p_i)}
        else:
            # We check whether there is a suitable promising graph present on the board.
            # If that is the case, we return this fact.
            # This implies that FP wins the game by Lemma 5.2 and we need not continue play.
            if promising_graph_present(board):
                return {'move': None, 'determined_finish': 'promising graph'}
            # If there is no winning configuration but at least 4 p_i,
            # then there cannot be an edge between two different p_i together with k,
            # thus FP can build a triangle on the p_i together with k.
            if len(list_of_p_i) == 5:
                subboard = nx.subgraph(board, list_of_p_i)
                if len(list(subboard.edges())) == 0:
                    return {'move': triangle_builder(board,list_of_p_i), 'determined_finish': 'triangle'}
                else:
                    raise Exception('There should be no edges on this subboard or we should not end up here')
            # If there is no winning configuration and fewer than 5 p_i,
            # FP claims an edge incident with 'FP_main' and a fresh vertex.
            else:
                most_recent_p_i = sorted(list_of_p_i,key = lambda x : board.nodes[x]['special_case_position'][-1])[-1]
                return {'move': (find_vertex_with_property(board, 'special_case_position', 'FP_main'),int(most_recent_p_i)+1), 'special_case_position': {int(most_recent_p_i)+1: 'p_{}'.format(int(board.nodes[most_recent_p_i]['special_case_position'][-1])+1)}}




def FP_edge(board, alg_stage=1):
    # First we check whether there is an opportunity for FP to just win.
    if threat_checker(board,'FP'):
        return {'move': threat_checker(board,'FP')[0], 'alg_stage': alg_stage}
    # Next we need to check wether there is a threat from SP to which FP needs to react to.
    threat = threat_checker(board,'SP')
    if threat:
        if len(threat) == 1:
            # In case 6 it might happen that FP already saved an information 
            # how she wants to continue playing.
            # But if SP manages to create a threat afterwards, 
            # we need to delete that information and we need to later find a
            # series of moves s.t. FP can win.
            if [x[0] for x in board.nodes.data('determined_finish') if x[1]]:
                return {'move': threat[0], 'determined_finish': 'delete', 'alg_stage': alg_stage}
            else:
                return {'move': threat[0], 'alg_stage': alg_stage}
        else:
            raise Exception('SP win.')
    # if there is no threat from SP, FP continues with her strategy
    if alg_stage == 1:
        # In stage 1 we prepare the board suitably and 
        # simply apply the function to build a triangle.
        # The preparation is to add any vertex from {1,2,3,4,5} to 
        # an auxiliary board that is not already present on the board.
        building_vertices = [vtx for vtx in board.nodes() if FP_degree(vtx, board) != 0]
        for vertex in [1,2,3,4,5]:
            if vertex not in building_vertices and len(building_vertices) <5:
                building_vertices.append(vertex)
        aux_board = nx.Graph()
        aux_board.add_edges_from(board.edges(data=True))
        aux_board.add_nodes_from(building_vertices)
        if len(FP_triangle_finish_checker(board)) != 0:
            next_stage = 2
        else:
            next_stage = 1
        return {'move': triangle_builder(aux_board, building_vertices), 'alg_stage': next_stage}
    elif alg_stage == 2:
        # Since the decision to divert to a special stage takes place during stage 2,
        # we check whether the board is isomorphic to one of the special situations here.
        # If the is the case, we change the stage and call FP_edge() again with the updated stage
        for special_graph in stage_6_graphs:
            if nx.is_isomorphic(special_graph,board,edge_match = em):
                alg_stage = 6
        for special_graph in stage_5_graphs:
            if nx.is_isomorphic(special_graph,board,edge_match = em):
                alg_stage = 5
        if alg_stage != 2:
            return FP_edge(board, alg_stage)
        # Otherwise, we really are in stage 2, FP has her triangle and 
        # wants to build a K_4^- with one SP edge.
        # First we check whether FP can finish her K_4^- in this turn.
        if can_get_K_four_minus(board):
            return {'move': list(nx.non_edges(board.subgraph(can_get_K_four_minus(board))))[0], 'alg_stage': 3}
        else:
            # Otherwise there is a triangle.
            # We add a fresh vertex to the board and an edge incident with 
            # that vertex and one of the vertices of the triangle with the highest SP degree.
            return {'move': (find_highest_SP_degree_in_substructure(board, find_FP_triangle(board)), max([vertex for vertex in board.nodes() if vertex < 10]) + 1), 'alg_stage': 2}
    elif alg_stage == 3:
        # In stage 3 FP wants to get the 5 outgoing edges attached to one
        # vertex of the K^4_-.
        # The first time we enter stage 3 we need to determine which vertex that is.
        # We also need to determine the vertex which FP wants to be incident with SPs edges.
        # Lastly we also need to determine the last two vertices of the K^4_-, 
        # the ones that SPs edges may also be incident to and to which FP wants to react to.
        # We use functions to determine the first two edges and the last two 
        # vertices of the K^4_- are assigned to the roles of SP_left and SP_right arbitrarily.
        if not flagged_vertex_present(board):
            vertexsubset = K_four_minus_checker(board)
            FP_prio_vertex = define_FP_favourite_vertex(board, vertexsubset)
            SP_prio_vertex = define_SP_favourite_vertex(board, vertexsubset)
            vertexsubset.remove(FP_prio_vertex)
            vertexsubset.remove(SP_prio_vertex)
            # After detemining the roles of the vertices of the K^4_-,
            # FP wants to add a fresh vertex and an edge from that vertex to her prio vertex.
            return {'move': (FP_prio_vertex, 20), 'alg_stage': 3, 'K_four_minus': [(FP_prio_vertex,{'K_four_minus':'FP_main'}), (SP_prio_vertex,{'K_four_minus':'SP_main'}), (vertexsubset[0],{'K_four_minus':'SP_left'}), (vertexsubset[1],{'K_four_minus':'SP_right'})]}
        else:
            previous_fresh_node = max([vertex for vertex in board.nodes() if 20 <= vertex < 30])
            # We check whether SP reacted as expected,
            # from the previous fresh node to 'SP_main'
            if (previous_fresh_node,find_vertex_with_property(board, 'K_four_minus', 'SP_main')) in board.edges():
                # If that is the case and the previous fresh node is
                # not the fifth of stage 3, i.e. '24',
                # then FP claims an edge from a fresh vertex to 'SP_main'.
                if previous_fresh_node < 24:
                    return {'move': (find_vertex_with_property(board, 'K_four_minus', 'FP_main'), previous_fresh_node+1), 'alg_stage': 3}
                else:
                    # otherwise FP wants to switch to stage 4.
                    return FP_edge(board, 4)
            # Otherwise SP did not react with an edge incident with previous_fresh_node and SP_main.
            elif (previous_fresh_node,find_vertex_with_property(board, 'K_four_minus', 'SP_left')) not in board.edges() and (previous_fresh_node,find_vertex_with_property(board, 'K_four_minus', 'SP_right')) not in board.edges():
                # If it was not one of the edges (previous_fresh_node,SP_left) and
                # (previous_fresh_node,SP_left), then FP claims (previous_fresh_node,SP_main),
                # wich means that there are two edges with which she can finish a K^4 in the following turn.
                return {'move': (find_vertex_with_property(board, 'K_four_minus', 'SP_main'), previous_fresh_node), 'alg_stage': 3}
            # If it was one of the edges (previous_fresh_node,SP_left) and
            # (previous_fresh_node,SP_left), then FP claims the other of the two.
            elif (previous_fresh_node,find_vertex_with_property(board, 'K_four_minus', 'SP_left')) not in board.edges():
                return {'move': (find_vertex_with_property(board, 'K_four_minus', 'SP_left'), previous_fresh_node), 'alg_stage': 3}
            else:
                return {'move': (find_vertex_with_property(board, 'K_four_minus', 'SP_right'), previous_fresh_node), 'alg_stage': 3}
    elif alg_stage == 4:
        # In stage 4 FP wants to build a K_4 on the 5 outgoing edges.
        return {'move': triangle_builder(board, list(range(20,25))), 'alg_stage': 4}
    elif alg_stage == 5:
        # Stage 5 is the first of the two special cases where FP cannot persue her regular strategy.
        # We have a dedicated funtion for that stage.
        return stage_five(list(board.edges(data=True)),list(board.nodes(data=True)))
    else:
        # Stage 6 is the second of the two special cases where FP cannot persue her regular strategy.
        # We have a dedicated funtion for that stage.
        # Once FP entered stage 6, she will not leave it again until she won,
        # thus we can add the stage after calling stage_six().
        output = stage_six(list(board.edges(data=True)),list(board.nodes(data=True)))
        output['alg_stage'] = 6
        return output


def move(board_edges = [], board_vertices = [], alg_stage = 1):
    # The move() function is executing the moves of the game.
    # It takes the board edges and vertices as arguments, calls FP_edge(),
    # adds the edge that it returns to the board, then loops through all possible
    # edges for SP and in each loop adds the respective edge to the baord and 
    # calls itself again with the board information and the algorithm stage information.
    # We begin by creating the board.
    board = nx.Graph()
    board.add_edges_from(board_edges)
    board.add_nodes_from(board_vertices)
    step = len(board_edges)
    # Then FP_edge() is called with the board and the stage.
    FP_info = FP_edge(board, alg_stage)
    if 'determined_finish' in FP_info:
        if FP_info['determined_finish'] == 'promising graph':
            return True
    # Next we check whether FP wants to incorporate a fresh vertex into G_{FP} in this turn.
    # If she does, we count how many vertices there are that are incident with claimed edges.
    # With this we can check how big a potential board must at least be s.t. FP can execute her strategy 
    # up to this point.
    for vertex in FP_info['move']:
        if vertex not in board.nodes():
            global number_of_required_vertices
            # If the board size plus the fresh vertex is more than the previous
            # required size, we store this as the new required size.
            if board.number_of_nodes() + 1 > number_of_required_vertices:
                number_of_required_vertices = board.number_of_nodes() + 1
                if number_of_required_vertices >= 18:
                    with open('output.txt', 'a') as f:
                        print('Board edges of a graph that need more than 17 vertices :', file = f)
                        for edge in sorted([(*foo, board.get_edge_data(*foo)) for foo in board.edges()], key = lambda x : x[2]['added_in_step']):
                            print('{},'.format(edge), file = f)
            # Since FP always adds at most one fresh vertex (except for the first turn)
            # we can break the loop now.
            break
    # We add the edge of FP to the board.
    board.add_edges_from([FP_info['move']], colour = 'FP' , added_in_step = step)
    # In stages 5 and 6, FP_edge() returns properties that should be assigned to vertices of the board.
    if 'special_case_position' in FP_info:
        for key,value in FP_info['special_case_position'].items():
            board.add_node(key, special_case_position = value)
    # If FP switches from stage 5 to stage 3,
    # the property of the vertices must be adjusted
    if alg_stage == 5 and FP_info['alg_stage'] == 3:
        for vertex in list(board.nodes(data=True)):
            if 'special_case_position' in vertex[1]:
                if board.nodes[vertex[0]]['special_case_position'] in ['FP_main','SP_main','SP_left','SP_right']:
                    board.nodes[vertex[0]]['K_four_minus'] = board.nodes[vertex[0]]['special_case_position']
                del board.nodes[vertex[0]]['special_case_position']
    # Sometimes we want to rename vertices of the board.
    if 'mapping' in FP_info:
        board = nx.relabel_nodes(board, FP_info['mapping'])
    # In the beginning of stage 3, we flag the vertices of the K^4_-.
    if 'K_four_minus' in FP_info:
        board.add_nodes_from(FP_info['K_four_minus'])
    # In stages 5 and 6 we sometimes wants to save a particular information,
    # how FP can win from that point on.
    # We assign this to the FP_main vertex as a property.
    if 'determined_finish' in FP_info:
        if FP_info['determined_finish'] == 'delete':
            del board.nodes[find_vertex_with_property(board, 'special_case_position', 'FP_main')]['determined_finish']
        else:
            board.add_node(find_vertex_with_property(board, 'special_case_position','FP_main'), determined_finish = FP_info['determined_finish'])
    # We need to check, whether there is some monochromatic K^4 on the board.
    monochromatic_subgraph = win_checker(board)
    # If FP wins, we want to check whether this game went on for more rounds
    # than the previous longest game length.
    # To check this we need to initialise the maximum_game_length varaible.
    global maximum_game_length_number_of_moves
    global maximum_game_length_board
    if monochromatic_subgraph:
        # If there is a monochromatic K^4, and it is claimed by FP, then she won.
        if (board[monochromatic_subgraph[0]][monochromatic_subgraph[1]]['colour'] == 'FP'):
            if board.number_of_edges() > maximum_game_length_number_of_moves:
                maximum_game_length_board.add_edges_from(board.edges(data=True))
                maximum_game_length_board.add_nodes_from(board.nodes(data=True))
                maximum_game_length_number_of_moves = board.number_of_edges()
            return True
        # If it is claimed by SP, then FP lost.
        else:
            raise Exception('SP win')
    # We check whether there is a threat by FP to which SP has to react.
    SP_has_no_choice = threat_checker(board,'FP')
    # If there is more than one threat by FP, then she won the game.
    if len(SP_has_no_choice) > 1:
        if board.number_of_edges() + 2 > maximum_game_length_number_of_moves:
            # We add 2 to the maximum game length, because SP and FP still need to
            # make one move each until the game truly ends with a win by FP
            maximum_game_length_board.add_edges_from(board.edges(data=True))
            maximum_game_length_board.add_nodes_from(board.nodes(data=True))
            maximum_game_length_number_of_moves = board.number_of_edges()+2
        return True
    # Otherwise, if there is precisely one threat by FP, then SP must claim that edge,
    # because otherwise he lost.
    elif len(SP_has_no_choice) == 1:
        board.add_edges_from([SP_has_no_choice[0]], colour = 'SP', added_in_step = step + 1)
        for vertex in list(nx.isolates(board)):
            board.remove_node(vertex)
        move(list(board.edges(data=True)), list(board.nodes(data=True)), int(FP_info['alg_stage']))
    # Otherwise, there is no threat by FP.
    else:
        # In this case we need to go through every possible move for SP.
        # First we make sure that there are exactly 2 vertices with no incident edges.
        # This ensures that, even though there are infinitely many vertices on the board,
        # we check all possible moves for SP up to isomorphism.
        for i in range(2-nx.number_of_isolates(board)):
            board.add_node(max(board.nodes()) + 1)
        # We create a list of all possible moves for SP, 
        # which is any unclaimed edge on the current board.
        for edge in list(nx.non_edges(board)):
            # During stage 3, there is only a small subset of non-edges of the board that 
            # make sense for FP to try since the others do not offer new opportunities
            # and by skipping them we can reduce runtime.
            # If one chooses so the following statement may be commented out 
            # and the algorithm will still work and check for even more board positions.
            # This will prolong the runtime at least sixfold.
            if 20 in board.nodes() and flagged_vertex_present(board):
                FP_prio_vtx, SP_prio_vtx = find_vertex_with_property(board, 'K_four_minus', 'FP_main'), find_vertex_with_property(board, 'K_four_minus', 'SP_main')
                if {FP_info['move'][0],FP_info['move'][1]} == {FP_prio_vtx,20}:
                    if {edge[0],edge[1]} != {SP_prio_vtx,20}:
                        continue
                elif {FP_info['move'][0],FP_info['move'][1]} == {FP_prio_vtx,21}:
                    if {edge[0],edge[1]} != {SP_prio_vtx,21}:
                        continue
                elif {FP_info['move'][0],FP_info['move'][1]} == {FP_prio_vtx,22}:
                    if {edge[0],edge[1]} != {SP_prio_vtx,22}:
                        continue
                elif {FP_info['move'][0],FP_info['move'][1]} == {FP_prio_vtx,23}:
                    if {edge[0],edge[1]} not in [{find_vertex_with_property(board, 'K_four_minus', 'SP_main'),23},{find_vertex_with_property(board, 'K_four_minus', 'SP_left'),23},{find_vertex_with_property(board, 'K_four_minus', 'SP_right'),23}]:
                        continue
            # We add SPs edge to the board.
            board.add_edges_from([edge], colour = 'SP', added_in_step = step + 1)
            # We delete the vertices of degree 0 from the board before continuing to the next move.
            for vertex in list(nx.isolates(board)):
                board.remove_node(vertex)
            # Next, we call the move() function again.
            move(list(board.edges(data=True)), list(board.nodes(data=True)), int(FP_info['alg_stage']))
            # Afterwards, we need to delete SPs edge from the board in this case,
            # so we can add the next one during the loop.
            board.remove_edge(*edge)
            
            
            
            
            
            
            
            
            
            
            
            
            